#include "qtdemoquery.h"
#include "qtscopebridge.h"
#include <QEvent>
#include <QCoreApplication>
#include <unity/scopes/Annotation.h>
#include <unity/scopes/CategorisedResult.h>
#include <unity/scopes/CategoryRenderer.h>
#include <unity/scopes/Query.h>
#include <unity/scopes/SearchReply.h>

using namespace unity::scopes;

QtDemoQuery::QtDemoQuery(std::string const& query) :
query_(query)
{
}

QtDemoQuery::~QtDemoQuery()
{
}

void QtDemoQuery::cancelled()
{
}

void QtDemoQuery::run(unity::scopes::SearchReplyProxy const& reply)
{
    QCoreApplication *app = QCoreApplication::instance();
    QtScopeBridge *q = new QtScopeBridge(QString::fromUtf8(query_.c_str()), reply);
    q->moveToThread(app->thread());
    QEvent *e = new QEvent(QEvent::None); // The event type is irrelevant.
    app->postEvent(q, e);
}
