#include "qtdemoscope.h"
#include "qtdemoquery.h"
#include<QCoreApplication>
#include <unity-scopes.h>

using namespace unity::scopes;

int QtDemoScope::start(std::string const&, unity::scopes::RegistryProxy const&)
{
    return VERSION;
}

void QtDemoScope::run() {
    int zero = 0;
    app = new QCoreApplication(zero, nullptr);
    app->exec();
    delete app; // If exec throws this leaks, but the process will die in milliseconds so we don't care.
}

void QtDemoScope::stop()
{
    app->quit();
}

QueryBase::UPtr QtDemoScope::create_query(std::string const& q,
        unity::scopes::VariantMap const&)
{
    unity::scopes::QueryBase::UPtr query(new QtDemoQuery(q));
    return query;
}

QueryBase::UPtr QtDemoScope::preview(Result const& /*result*/, VariantMap const& /*hints*/) {
    return nullptr;
}

#define EXPORT __attribute__ ((visibility ("default")))

extern "C"
{

    EXPORT
    unity::scopes::ScopeBase*
    // cppcheck-suppress unusedFunction
    UNITY_SCOPE_CREATE_FUNCTION()
    {
        return new QtDemoScope();
    }

    EXPORT
    void
    // cppcheck-suppress unusedFunction
    UNITY_SCOPE_DESTROY_FUNCTION(unity::scopes::ScopeBase* scope_base)
    {
        delete scope_base;
    }

}
