#include"qtscopebridge.h"
#include<unity-scopes.h>

using namespace unity::scopes;

QtScopeBridge::QtScopeBridge(QString query, unity::scopes::SearchReplyProxy proxy) :
    query(query), proxy(proxy), started(false) {
}

QtScopeBridge::~QtScopeBridge() {
}

bool QtScopeBridge::event(QEvent *e) {
    if(started) {
        return QObject::event(e);
    }
    started = true;
    /* At this point we are under Qt control and can do whatever
     * we want with Qt libraries and callbacks. For this simple demo we
     * just create a single reply and then unregister ourselves.
     */
    CategoryRenderer rdr;
    auto cat = proxy->register_category("cat1", "Category 1", "", rdr);
    CategorisedResult res(cat);
    res.set_uri("uri");
    res.set_title("Qt Demo scope result");
    res.set_art("icon");
    res.set_dnd_uri("dnd_uri");
    proxy->push(res);

    Query q("Qt Demo Scope");
    Annotation annotation(Annotation::Type::Link);
    annotation.add_link("More...", q);
    proxy->push(annotation);
    // All results are pushed, time to remove ourselves.
    // Destruction of *this object signals the end of the result set.
    deleteLater();
    return true;
}
